/*
 * 
 * SIP CALL LEG FRAME DEFINE
 * Copyright 2011-2012 KWANGHAESOFT LTD.
 * Creator: JGK
 * PUBLISH DATE: Dec. 2011
 * 
 */
package bssoft.stack.sip;
import java.util.Date;

public class UPDATEHeaders {
	
	public String commandLine				= null;
	public String viaH						= null;
	public StringBuffer viaArray			= null;
	public String routeH					= null;
	public StringBuffer routeArray 		= null;
	public String recordrouteH				= null;
	public StringBuffer recordrouteArray	= null;
	public String maxforwardH				= null;
	public String contactH					= null;
	public String toH						= null;
	public String fromH					= null;
	public String callidH					= null;
	public String cseqH					= null;
	public String expiresH					= null;
	public String allowH					= null;
	public String useragentH				= null;
	public String remoteuseragentH			= null;
	public String contentlengthH			= null;
	public String contenttypeH				= null;
	public String authorizationINVITEH		= null;
	public String authorizationCANCELH		= null;
	public String authorizationBYEH		= null;
	public String authorizationACKH		= null;
	public String passertedidentityH		= null;
	public String serverIp					= null;
	public int	serverPort					= 5060;
	public String serverDomain				= null;
	public String remoteIp					= null;
	public int	remotePort					= 5060;
	public String remoteContactIp			= null;
	public int	remoteContactPort			= 5060;
	public String remoteContactUri			= null;
	public String localIp					= null;
	public int	localPort					= 5060;
	public String id						= null;
	public String cid						= null;
	public String authid					= null;
	public String authpassword				= null;
	public String fromTag					= null;
	public String toTag					= null;
	public String fromHeaderValue			= null;
	public String toHeaderValue			= null;
	public String callId					= null;
	public String dnis						= null;
	public String viaBranch				= null;//2013 02 13
	public int CSEQ_NUMBER					= SIPStack.SIP_SEQUENCE_INVITE;
	public int INVITE_CSEQ					= 0;
	public int CANCEL_CSEQ					= 0;
	public int ACK_CSEQ					= 0;
	public int BYE_CSEQ					= 0;
	public int callDirection				= SIPStack.SIP_CALLDIRECTION_NONE;
	
	public int callState					= SIPStack.SIP_CALLSTATE_IDLE;
	public int callMode					= SIPStack.SIP_CALLMODE_NONE;
	public Date callTime_TI				= null;//idle timer
	public Date callTime_T0				= null;//invite timer
	public Date callTime_T00				= null;//invite timer
	public int invitingTimes				= 0;
	public Date callTime_T1				= null;//proceeding timer
	public Date callTime_T2				= null;//progressing timer
	public Date callTime_T3				= null;//accepted timer
	public Date callTime_T4				= null;//connected timer
	public Date callTime_T40				= null;//connected duration report timer
	public Date callTime_T5				= null;//disconnecting timer
	public Date callTime_T6				= null;//terminating timer
	public Date callTime_T7				= null;//offerred timer
	public Date callTime_T8				= null;//cancelling timer
	public Date callTime_T9				= null;//bye timer

	public int expiresTI					= 0;//idle timer  seconds
	public int expiresT0					= 0;//invite timer  seconds
	public int expiresT00					= 0;//invite timer  seconds
	public int expiresT1					= 0;//proceeding timer  seconds
	public int expiresT2					= 0;//progressing timer  seconds
	public int expiresT3					= 0;//accepted timer  seconds
	public int expiresT4					= 0;//connected timer  seconds
	public int expiresT5					= 0;//disconnecting timer  seconds
	public int expiresT6					= 0;//terminating timer  seconds
	public int expiresT7					= 0;//offerred timer   seconds
	public int expiresT8					= 0;//cancelling timer  seconds
	public int expiresT9					= 0;//bye timer  milli seconds

	//SDP
	public SIPSdp	sdp						= null;
	public SIPSdp	remoteSdp				= null;
	//

	public String message					= null;
	
	//DEVELOPEMENT CONTROL
	public boolean flag;
	
	
	public UPDATEHeaders() {
		if(SIPStack.SIP_CALLHANDLE_DEBUG==true) System.out.println("call handle created.");
		CSEQ_NUMBER		= SIPStack.SIP_SEQUENCE_INVITE;
		
		callState		= SIPStack.SIP_CALLSTATE_IDLE;
		callMode		= SIPStack.SIP_CALLMODE_BASIC;
		callTime_TI		= new Date();
		callTime_T0		= new Date(); 
		callTime_T00	= new Date(); 
		invitingTimes	= 0;
		callTime_T1		= new Date();
		callTime_T2		= new Date();
		callTime_T3		= new Date();
		callTime_T4		= new Date();
		callTime_T40	= new Date();
		callTime_T5		= new Date();
		callTime_T6		= new Date();
		callTime_T7		= new Date();
		callTime_T8		= new Date();
		callTime_T9		= new Date();//2015 06 19
		expiresTI		= 0;
		expiresT0		= 0;
		expiresT00		= 0;
		expiresT1		= 0;
		expiresT2		= 0;
		expiresT3		= 0;
		expiresT4		= 0;
		expiresT5		= 0;
		expiresT6		= 0;
		expiresT7		= 0;
		expiresT8		= 0;
		expiresT9		= 0;//2015 06 19

		sdp				= null;
		remoteSdp		= null;
		
		flag=false;
	}
	public void reset()
	{
		commandLine				= null;
		viaH					= null;
		viaArray				= null;
		routeH					= null;
		routeArray 				= null;
		recordrouteH			= null;
		recordrouteArray		= null;
		maxforwardH				= null;
		contactH				= null;
		toH						= null;
		fromH					= null;
		callidH					= null;
		cseqH					= null;
		expiresH				= null;
		allowH					= null;
		useragentH				= null;
		remoteuseragentH		= null;
		contentlengthH			= null;
		contenttypeH			= null;
		authorizationINVITEH	= null;
		authorizationCANCELH	= null;
		authorizationBYEH		= null;
		authorizationACKH		= null;
		passertedidentityH		= null;
		serverIp				= null;
		serverPort				= 5060;
		serverDomain			= null;
		remoteIp				= null;
		remotePort				= 5060;
		remoteContactIp			= null;
		remoteContactPort		= 5060;
		remoteContactUri		= null;
		localIp					= null;
		localPort				= 5060;
		id						= null;
		cid						= null;
		authid					= null;
		authpassword			= null;
		fromTag					= null;
		toTag					= null;
		fromHeaderValue			= null;
		toHeaderValue			= null;

		callId					= null;
		dnis					= null;
		viaBranch				= null;//2013 02 13
		CSEQ_NUMBER				= SIPStack.SIP_SEQUENCE_INVITE;
		INVITE_CSEQ				= 0;
		CANCEL_CSEQ				= 0;
		ACK_CSEQ				= 0;
		BYE_CSEQ				= 0;
		callDirection			= SIPStack.SIP_CALLDIRECTION_NONE;
		
		callState				= SIPStack.SIP_CALLSTATE_IDLE;
		callMode				= SIPStack.SIP_CALLMODE_NONE;
		callTime_TI				= null;//idle timer
		callTime_T0				= null;//invite timer
		callTime_T00			= null;//2012 11 29
		invitingTimes			= 0;
		callTime_T1				= null;//proceeding timer
		callTime_T2				= null;//progressing timer
		callTime_T3				= null;//accepted timer
		callTime_T4				= null;//connected timer
		callTime_T40			= null;//connected duration report timer
		callTime_T5				= null;//disconnecting timer
		callTime_T6				= null;//terminating timer
		callTime_T7				= null;//offerred timer
		callTime_T8				= null;//cancelling timer
		callTime_T9				= null;//bye timer

		expiresTI				= 0;//idle timer
		expiresT0				= 0;//invite timer
		expiresT00				= 0;//invite timer
		expiresT1				= 0;//proceeding timer
		expiresT2				= 0;//progressing timer
		expiresT3				= 0;//accepted timer
		expiresT4				= 0;//connected timer
		expiresT5				= 0;//disconnecting timer
		expiresT6				= 0;//terminating timer
		expiresT7				= 0;//offerred timer
		expiresT8				= 0;//cancelling timer
		expiresT9				= 0;//bye timer

		//SDP
		sdp						= null;
		remoteSdp				= null;
		//

		message					= null;
		
		//DEVELOPEMENT CONTROL
		flag=false;
		
	}
}